"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getRoutePaths;

var _lodash = require("lodash");

function getRoutePaths(routes) {
  return (0, _lodash.uniq)(routes.reduce((memo, route) => {
    if (route.path) {
      memo.push(route.path);

      if (route.routes) {
        memo = memo.concat(getRoutePaths(route.routes));
      }
    }

    return memo;
  }, []));
}